import numpy as np

from ddm.core.commons.binning import uniform_axis as uniform, uniform_step_axis
from ddm.fast.variables.variables import VariableTemplate as t

mudict = {
    'id': t('{id}', 'pat mu id', None, uniform(10, 0., 10.), is_per_muon=True),
    'pt': t('{type}mu_pt[{id}]', 'p_{T}', 'GeV', uniform(50, 0., 100.), is_per_muon=True),
    'eta': t('{type}mu_eta[{id}]', '#eta', None, uniform(20, -3., 3.), is_per_muon=True),
    'abseta': t('abs({type}mu_eta[{id}])', '|#eta|', None, uniform(20, 0., 3.), is_per_muon=True),
    'phi': t('{type}mu_phi[{id}]', '#phi', None, uniform(20, -3.2, 3.2), is_per_muon=True),
    'muoniso': t('dim_mu{num}_iso', 'I^{rel}_{STA}', None, uniform(20, 0., 1.), is_per_muon=True),
    'isoPmumu': t('dim_isoPmumu', 'I^{rel}_{STA}(p^{#mu#mu})', None, uniform(20, 0., 1.), is_per_muon=False),
    'isoLxy': t('dim_isoLxy', 'I^{rel}_{STA}(Lxy)', None, uniform(20, 0., 1.), is_per_muon=False),
    'cleanedmuoniso': t('dim_mu{num}_cleanedIso', 'I^{rel}_{STA}(cleaned)', None, uniform(20, 0., 1.), is_per_muon=True),
    'PATcleanedmuoniso': t('dsamu_PATcleanedIso', 'I^{rel}_{STA}(cleaned)', None, uniform(20, 0., 1.), is_per_muon=True),
    'PATcorrectedmuoniso': t('dsamu_PATcorrectedIso', 'I^{rel}_{STA}(corrected)', None, uniform(20, 0., 1.), is_per_muon=True),
    'pfiso3': t('{type}mu_pfIso03[{id}]/{type}mu_pt[{id}]', 'rel pf iso (0.3)', None, uniform(20, 0., 1.), is_per_muon=True),
    'ecaliso': t('{type}mu_ecalIso[{id}]/{type}mu_pt[{id}]', 'rel ecal iso', None, uniform(20, 0., 1.), is_per_muon=True),
    'hcaliso': t('{type}mu_hcalIso[{id}]/{type}mu_pt[{id}]', 'rel hcal iso', None, uniform(20, 0., 1.), is_per_muon=True),
    'caliso': t('({type}mu_ecalIso[{id}]+{type}mu_hcalIso[{id}])/{type}mu_pt[{id}]', 'rel ecal+hcal iso', None, uniform(20, 0., 1.), is_per_muon=True),
    'trkchi2': t('{type}mu_chi2[{id}]/{type}mu_ndof[{id}]', 'trkr trk #chi^{2}/dof', None, uniform(50, 0., 50.), is_per_muon=True),
    'probtrkchi2': t('TMath::Prob({type}mu_chi2[{id}],{type}mu_ndof[{id}])', 'Prob. #chi^{2}/dof', None, uniform(50, 0., 50.), is_per_muon=True),
    'globchi2': t('{type}mu_globchi2[{id}]/{type}mu_globndof[{id}]', 'glbl trk #chi^{2}/dof', None, uniform(50, 0., 50.), is_per_muon=True),
    'tkstachi2': t('{type}mu_tkstachi2[{id}]', 'trkr stn mtch #chi^2/dof', None, uniform(40, 0., 20.), is_per_muon=True),
    'kinkchi2': t('{type}mu_kinkchi2[{id}]', 'kink #chi^{2}/dof', None, uniform(50, 0., 50.), is_per_muon=True),
    'nmatchedstat': t('{type}mu_nMatchedStations[{id}]', 'N(Matched stations)', None, uniform(10, 0., 10.), is_per_muon=True),
    'fpte': t('{type}mu_ptError[{id}]/{type}mu_pt[{id}]', '#sigma_{p_{T}}/p_{T}', None, uniform(50, 0., 1.), is_per_muon=True),
    'fpteref': t('dim_mu{num}_ptError/dim_mu{num}_pt', 'refitted #sigma_{p_{T}}/p_{T}', None, uniform(50, 0., 1.), is_per_muon=True),
    'nseg': t('{type}mu_nCSCStations[{id}]+{type}mu_nDTStations[{id}]', 'N(CSC+DT Stations)', None, uniform(10, 0., 10.), is_per_muon=True),
    'nmuhits': t('{type}mu_nCSCHits[{id}]+{type}mu_nDTHits[{id}]', 'N(CSC+DT Hits)', None, uniform(40, 0., 40.), is_per_muon=True),
    'ntrkhits': t('{type}mu_nTrackerHits[{id}]', 'N(Tracker Hits)', None, uniform(30, 0., 30.), is_per_muon=True),
    'ntrklays': t('{type}mu_nTrackerLayers[{id}]', 'N(Tracker Layers)', None, uniform(10, 0., 10.), is_per_muon=True),
    'ntrklayslxy': t('{type}mu_nTrackerLayers[{id}]+floor(dim_Lxy_pv/15)', 'N(Tracker Layers) + int(L_{xy})/15', None, uniform(10, 0., 10.), is_per_muon=True),
    'fracvldhits': t('{type}mu_fracValidTkHits[{id}]', 'fraction valid trkr hits', None, uniform(10, 0., 1.), is_per_muon=True),
    'npixelhits': t('{type}mu_nPixelHits[{id}]', 'N(Pixel hits)', None, uniform(20, 0., 20.), is_per_muon=True),
    'segmcomp': t('{type}mu_segmComp[{id}]', 'segment compatiblility', None, uniform(50, 0., 1.), is_per_muon=True),
    'ispf': t('{type}mu_isPF[{id}]', 'is particle flow', None, uniform(2, 0., 1.), is_per_muon=True),
    'isglob': t('{type}mu_isGlobal[{id}]', 'is global', None, uniform(2, 0., 1.), is_per_muon=True),
    'ism': t('{type}mu_isMedium[{id}]', 'is medium', None, uniform(2, 0., 1.), is_per_muon=True),
    'd0bs': t('{type}mu_d0_bs[{id}]', ' d_{0}  bs', 'cm', uniform(50, -0.025, 0.025), is_per_muon=True),
    'd0sigbs': t('{type}mu_d0sig_bs[{id}]', '|d_{0}|/#sigma_{d_{0}} bs', None, uniform(50, 0., 20.), is_per_muon=True),
    'd0errbs': t('{type}mu_d0_bs[{id}]/{type}mu_d0sig_bs[{id}]', '#sigma_{d_{0}} bs', 'cm', uniform(50, 0., 0.005), is_per_muon=True),
    'd0pv': t('abs({type}mu_d0_pv[{id}])', '|d_{0}|', 'cm', uniform(50, -0.025, 0.025), is_per_muon=True),
    'tmsd0pv': t('abs(patmu_d0_pv[dim_mu{num}_idx[dim_dim_idx]-1000])', 'TMS |d_{0}| pv', 'cm', uniform(50, -0.025, 0.025), is_per_muon=True),
    'smalld0sigpv': t('abs({type}mu_d0sig_pv[{id}])', 'd_{0}/#sigma_{d_{0}}', None, uniform_step_axis(0.2, 0., 2.), is_per_muon=True),
    'd0sigpv': t('abs({type}mu_d0sig_pv[{id}])', 'd_{0}/#sigma_{d_{0}}', None, uniform_step_axis(2, 0., 30.), is_per_muon=True),
    'd0errpv': t('abs({type}mu_d0_pv[{id}]/{type}mu_d0sig_pv[{id}])', '#sigma_{d_{0}} pv', 'cm', uniform(50, 0., 0.005), is_per_muon=True),
    'dzbs': t('{type}mu_dz_bs[{id}]', ' d_{z}  bs', 'cm', uniform(50, -50., 50.), is_per_muon=True),
    'dzsigbs': t('{type}mu_dzsig_bs[{id}]', '|d_{z}|/#sigma_{d_{z}} bs', None, uniform(20, 0., 100.), is_per_muon=True),
    'dzerrbs': t('{type}mu_dz_bs[{id}]/{type}mu_dzsig_bs[{id}]', '#sigma_{d_{z}} bs', 'cm', uniform(20, 0., 0.1), is_per_muon=True),
    'dzpv': t('{type}mu_dz_pv[{id}]', ' d_{z}  pv', 'cm', uniform(20, -0.1, 0.1), is_per_muon=True),
    'dzsigpv': t('{type}mu_dzsig_pv[{id}]', '|d_{z}|/#sigma_{d_{z}} pv', None, uniform(20, 0., 10.), is_per_muon=True),
    'dzerrpv': t('{type}mu_dz_pv[{id}]/{type}mu_dzsig_pv[{id}]', '#sigma_{d_{z}} pv', 'cm', uniform(20, 0., 0.05), is_per_muon=True),
    'misshits': t('dim_mu{num}_missingHitsAfterVtx', 'missing hits after vtx', None, uniform(10, 0., 10.), is_per_muon=True),
    'hitsb4vtx': t('dim_mu{num}_hitsBeforeVtx', 'hits before vtx', None, uniform(10, 0., 10.), is_per_muon=True),
    "deltaphimulxy": t("deltaphi({type}mu_phi[{id}],phi(dim_x,dim_y,dim_z,vtx_pv_x,vtx_pv_y,vtx_pv_z))", "|#phi_{#mu} #minus #phi_{Lxy}|", None, uniform(20, -3.2, 3.2), is_per_muon=True),
    "deltaphimudim": t("deltaphi({type}mu_phi[{id}],dim_phi)", "|#phi_{#mu} #minus #phi_{#mu#mu}|", None, uniform(20, -3.2, 3.2), is_per_muon=True),
    'cschits': t('{type}mu_nCSCHits[{id}]', 'csc hits', None, uniform(40, 0., 40.), is_per_muon=True),
    'dthits': t('{type}mu_nDTHits[{id}]', 'dt hits', None, uniform(40, 0., 40.), is_per_muon=True),
    'dthitscschits0': t('{type}mu_nDTHits[{id}]*({type}mu_nCSCHits[{id}]==0)', 'dt hits #times (csc hits==0)', None, uniform(40, 10., 50.), is_per_muon=True),
    'absrefd0pv': t('abs(dim_mu{num}_d0_rpv)', '|d_{0}| refit pv', 'cm', uniform(50, 0., 0.025), is_per_muon=True),
    'refd0sigpv': t('dim_mu{num}_d0sig_rpv', '|d_{0}|/#sigma_{d_{0}} refit pv', None, uniform(20, 0., 20.), is_per_muon=True),
    'absrefdzpv': t('abs(dim_mu{num}_dz_rpv)', '|d_{z}| refit pv', 'cm', uniform(50, 0., 50.), is_per_muon=True),
    'refdzsigpv': t('dim_mu{num}_dzsig_rpv', '|d_{z}|/#sigma_{d_{z}} refit pv', None, uniform(20, 0., 10.), is_per_muon=True),
    'charge': t('dim_mu{num}_charge', 'muon charge', None, uniform_step_axis(1, -1., 1., align='center'), is_per_muon=True),
    'iso': t('(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2)/{type}mu_pt[{id}]', 'rel iso', None, uniform(20, 0., 0.1), is_per_muon=True),
    'largeiso': t('(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2)/{type}mu_pt[{id}]', 'rel iso', None, uniform(20, 0., 0.75), is_per_muon=True),
    'trkiso': t('{type}mu_trackIso[{id}]/{type}mu_pt[{id}]', 'rel tracker iso', None, uniform(20, 0., 1.), is_per_muon=True),
    'time': t('{type}mu_timeAtIpInOut[{id}]', 'time', 'ns', uniform(60, -30.0, 30.0), is_per_muon=True),
    'statime': t('{type}mu_closSTA_timeAtIpInOut[{id}]', 'time of matched SA muon', 'ns', uniform(60, -30.0, 30.0), is_per_muon=True),
    'timeerror': t('{type}mu_timeAtIpInOutErr[{id}]', '#sigma_{time}', 'ns', uniform(80, -20.0, 20.0), is_per_muon=True),
    'timeerrordiff': t('{type}mu_timeAtIpOutInErr[{id}] - {type}mu_timeAtIpInOutErr[{id}]', '#sigma_{time}^{OutIn} - #sigma_{time}^{InOut}', 'ns', uniform(50, -5.0, 5.0), is_per_muon=True),
    'time_rpc': t('{type}mu_timeAtIpInOut_RPC[{id}]', 'RPC time', 'ns', uniform(60, -30.0, 30.0), is_per_muon=True),
    'timeerror_rpc': t('{type}mu_timeAtIpInOutErr_RPC[{id}]', '#sigma_{RPC time}', 'ns', uniform(80, -20.0, 20.0), is_per_muon=True),
    'direction': t('{type}mu_direction[{id}]', 'direction', None, uniform(5, -2.0, 3.0), is_per_muon=True),
    'hltppid': t('{type}mu_hltdim_pp_idx[{id}]', 'hlt index', None, uniform(20, 0.0, 20), is_per_muon=True),
    'pmgenid': t('{type}mu_gen_idx[{id}]', 'gen prox match index', None, uniform(20, 0., 20.), is_per_muon=True, is_gen=True),
    "pmgenpt": t("gen_pt[{type}mu_gen_idx[{id}]]", "gen prox match p_{T}", 'GeV/c', uniform(50, 0., 100), is_per_muon=True, is_gen=True),
    "pmgenabspt": t("abs(gen_pt[{type}mu_gen_idx[{id}]])", "gen prox match |p_{T}|", 'GeV/c', uniform(50, 0., 100), is_per_muon=True, is_gen=True),
    "pmgeneta": t("gen_eta[{type}mu_gen_idx[{id}]]", "gen prox match #eta", None, uniform(20, -3., 3.), is_per_muon=True, is_gen=True),
    "pmgenphi": t("gen_phi[{type}mu_gen_idx[{id}]]", "gen prox match #phi", None, uniform(20, -3.2, 3.2), is_per_muon=True, is_gen=True),
    "pmgend0bs": t("gen_d0[{type}mu_gen_idx[{id}]]", "gen prox match d_{0} bs", 'cm', uniform(50, -0.025, 0.025), is_per_muon=True, is_gen=True),
    "pmgenabsd0bs": t("abs(gen_d0[{type}mu_gen_idx[{id}]])", "gen prox match |d_{0}| bs", 'cm', uniform(50, -0.025, 0.025), is_per_muon=True, is_gen=True),
    "pmgenx": t("gen_x[{type}mu_gen_idx[{id}]]", "gen prox match x", 'cm', uniform(10, 0., 10.), is_per_muon=True, is_gen=True),
    "pmgeny": t("gen_y[{type}mu_gen_idx[{id}]]", "gen prox match y", 'cm', uniform(10, 0., 10.), is_per_muon=True, is_gen=True),
    "pmgenz": t("gen_z[{type}mu_gen_idx[{id}]]", "gen prox match z", 'cm', uniform(10, 0., 10.), is_per_muon=True, is_gen=True),
    "pmgencharge": t("gen_charge[{type}mu_gen_idx[{id}]]", "gen prox match charge", None, uniform_step_axis(1, -2., 2., align='center'), is_per_muon=True, is_gen=True),
    "pmgenmother": t("Alt$(gen_pdgID[gen_mother[{type}mu_gen_idx[{id}]]], -9999999)", "gen prox match mother", None, uniform(2000, -1000, 1000.), is_per_muon=True, is_gen=True),
    "hltmatch": t("({type}mu_hltdim_pp_idx[{id}]!=100||{type}mu_hltdim_cosmic_idx[{id}]!=100)", 'hlt matched muon', None, uniform(2, 0., 1.), is_per_muon=True),
    "hltppmatch": t("{type}mu_hltdim_pp_idx[{id}]!=100", 'hlt pp matched muon', None, uniform(2, 0., 1.), is_per_muon=True),
    "hltcosmicmatch": t("{type}mu_hltdim_cosmic_idx[{id}]!=100", 'hlt cosmic matched muon', None, uniform(2, 0., 1.), is_per_muon=True),
    "genptdiff": t("({type}mu_pt[{id}]-gen_pt[dim_mu{num}_gen_idx])/gen_pt[dim_mu{num}_gen_idx]", "reco - gen / gen p_{T}", None, uniform(50, -1., 3), is_per_muon=True, is_gen=True),
    "absgenptdiff": t("({type}mu_pt[{id}]-gen_pt[dim_mu{num}_gen_idx])", "abs(reco - gen  p_{T})", None, uniform(100, 0., 100), is_per_muon=True, is_gen=True),
    "invgenptdiff": t("(1./{type}mu_pt[{id}]-1./gen_pt[dim_mu{num}_gen_idx])/(1./gen_pt[dim_mu{num}_gen_idx])", "1/reco - 1/gen / (1/gen) p_{T}", None, uniform(50, -1., 3), is_per_muon=True, is_gen=True),
    "absinvgenptdiff": t("abs(1./{type}mu_pt[{id}]-1./gen_pt[dim_mu{num}_gen_idx])/(1./gen_pt[dim_mu{num}_gen_idx])", "1/reco - 1/gen / (1/gen) p_{T}", None, uniform(50, 0.0001, 3), is_per_muon=True, is_gen=True),
    "refQOverpTdiffDSADSAPATPAT": t("dim_mu{num}_charge/dim_mu{num}_pt - dim_mu{num}_charge[dim_dim_idx]/dim_mu{num}_pt[dim_dim_idx]", "q/p_{T}^{(DSA)} - q/p_{T}^{(PAT)} (ref.)", None, uniform(50, -1, 1), is_per_muon=True),  # to be used with DSA3
    "qOverpTdiffDSADSAPATPAT": t("dsamu_charge[dim_mu{num}_idx]/dsamu_pt[dim_mu{num}_idx] - patmu_charge[dim_mu{num}_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu{num}_idx[dim_dim_idx]-1000]", "q/p_{T}^{(DSA)} - q/p_{T}^{(PAT)}", None, uniform(50, -1, 1), is_per_muon=True),  # to be used with DSA3
    'dimmugenid': t('dim_mu{num}_gen_idx', 'gen index', None, uniform(20, 0., 20.), is_per_muon=True, is_gen=True),

}

deprecatedmudict = {
    'direction': t('{type}mu_direction[{id}]', 'direction', None, uniform(5, -2.0, 3.0), is_per_muon=True),
    'scaledd0pv': t('abs({type}mu_d0_pv[{id}])/(dim_LxySig_pv*dim_mass/dim_pt)', '|d_{0}| pv / #tau', None, uniform(40, 0.0, 0.01), is_per_muon=True),
    'clnisor3z2xy1': t('(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p2_dxy0p1)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.3, |dz| < 0.2, d_{0} < 0.1', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor3z3xy1': t('(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p3_dxy0p1)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.3, |dz| < 0.3, d_{0} < 0.1', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor3z4xy1': t('(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p4_dxy0p1)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.3, |dz| < 0.4, d_{0} < 0.1', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor3z5xy1': t('(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p1)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.3, |dz| < 0.5, d_{0} < 0.1', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor3z2xy2': t('(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p2_dxy0p2)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.3, |dz| < 0.2, d_{0} < 0.2', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor3z3xy2': t('(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p3_dxy0p2)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.3, |dz| < 0.3, d_{0} < 0.2', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor3z4xy2': t('(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p4_dxy0p2)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.3, |dz| < 0.4, d_{0} < 0.2', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor4z2xy1': t('(dim_mu{num}_clnd_tkiso0p4_sumPt_dz0p2_dxy0p1)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.4, |dz| < 0.2, d_{0} < 0.1', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor4z3xy1': t('(dim_mu{num}_clnd_tkiso0p4_sumPt_dz0p3_dxy0p1)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.4, |dz| < 0.3, d_{0} < 0.1', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor4z4xy1': t('(dim_mu{num}_clnd_tkiso0p4_sumPt_dz0p4_dxy0p1)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.4, |dz| < 0.4, d_{0} < 0.1', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor4z5xy1': t('(dim_mu{num}_clnd_tkiso0p4_sumPt_dz0p5_dxy0p1)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.4, |dz| < 0.5, d_{0} < 0.1', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor4z2xy2': t('(dim_mu{num}_clnd_tkiso0p4_sumPt_dz0p2_dxy0p2)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.4, |dz| < 0.2, d_{0} < 0.2', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor4z3xy2': t('(dim_mu{num}_clnd_tkiso0p4_sumPt_dz0p3_dxy0p2)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.4, |dz| < 0.3, d_{0} < 0.2', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor4z4xy2': t('(dim_mu{num}_clnd_tkiso0p4_sumPt_dz0p4_dxy0p2)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.4, |dz| < 0.4, d_{0} < 0.2', None, uniform(20, 0., 0.1), is_per_muon=True),
    'clnisor4z5xy2': t('(dim_mu{num}_clnd_tkiso0p4_sumPt_dz0p5_dxy0p2)/{type}mu_pt[{id}]', 'rel clnd (per dimuon) tk iso #DeltaR < 0.4, |dz| < 0.5, d_{0} < 0.2', None, uniform(20, 0., 0.1), is_per_muon=True),
    'rawclniso': t('{type}mu_cleanedIso[{id}]', 'cleaned iso', 'GeV', uniform(20, 0., 100.), is_per_muon=True),
    'ndof': t('{type}mu_ndof[{id}]', 'trkr trk dof', None, uniform(50, 0., 50.), is_per_muon=True),
    'dimd0bs': t('dim_mu{num}_d0_bs', 'dimuon  d_{0} bs', 'cm', uniform(50, -0.025, 0.025), is_per_muon=True),
    'dimd0sigbs': t('dim_mu{num}_d0sig_bs', 'dimuon |d_{0}|/#sigma_{d_{0}} bs', None, uniform(50, 0., 20.), is_per_muon=True),
    'dimd0errbs': t('dim_mu{num}_d0_bs/dim_mu{num}_d0sig_bs', 'dimuon #sigma_{d_{0}} bs', 'cm', uniform(50, 0., 0.005), is_per_muon=True),
    'dimd0pv': t('dim_mu{num}_d0_pv', 'dimuon  d_{0}  pv', 'cm', uniform(50, -0.025, 0.025), is_per_muon=True),
    'dimd0sigpv': t('dim_mu{num}_d0sig_pv', 'dimuon |d_{0}|/#sigma_{d_{0}} pv', None, uniform(20, 0., 20.), is_per_muon=True),
    'dimd0errpv': t('dim_mu{num}_d0_pv/dim_mu{num}_d0sig_pv', 'dimuon #sigma_{d_{0}} pv', 'cm', uniform(50, 0., 0.005), is_per_muon=True),
    'dimdzbs': t('dim_mu{num}_dz_bs', 'dimuon  d_{z}  bs', 'cm', uniform(50, -50., 50.), is_per_muon=True),
    'dimdzsigbs': t('dim_mu{num}_dzsig_bs', 'dimuon |d_{z}|/#sigma_{d_{z}} bs', None, uniform(20, 0., 100.), is_per_muon=True),
    'dimdzerrbs': t('dim_mu{num}_dz_bs/dim_mu{num}_dzsig_bs', 'dimuon #sigma_{d_{z}} bs', 'cm', uniform(20, 0., 0.1), is_per_muon=True),
    'dimdzpv': t('dim_mu{num}_dz_pv', 'dimuon  d_{z}  pv', 'cm', uniform(50, -50., 50.), is_per_muon=True),
    'dimdzsigpv': t('dim_mu{num}_dzsig_pv', 'dimuon |d_{z}|/#sigma_{d_{z}} pv', None, uniform(20, 0., 10.), is_per_muon=True),
    'dimdzerrpv': t('dim_mu{num}_dz_pv/dim_mu{num}_dzsig_pv', 'dimuon #sigma_{d_{z}} pv', 'cm', uniform(20, 0., 0.05), is_per_muon=True),
    'refd0pv': t('dim_mu{num}_d0_rpv', 'd_{0} refit pv', 'cm', uniform(50, -0.025, 0.025), is_per_muon=True),
    'd0bslin': t('{type}mu_d0_bs_lin[{id}]', ' d_{0}  b lin', 'cm', uniform(50, -0.025, 0.025), is_per_muon=True),
    'd0sigbslin': t('{type}mu_d0sig_bs_lin[{id}]', '|d_{0}|/#sigma_{d_{0}} bs lin', None, uniform(50, 0., 20.), is_per_muon=True),
    'd0pvlin': t('{type}mu_d0_pv_lin[{id}]', ' d_{0} pv lin', 'cm', uniform(50, -0.025, 0.025), is_per_muon=True),
    'd0sigpvlin': t('{type}mu_d0sig_pv_lin[{id}]', '|d_{0}|/#sigma_{d_{0}} pv lin', None, uniform(20, 0., 20.), is_per_muon=True),
    'chiso3': t('{type}mu_chHadPtR03[{id}]/{type}mu_pt[{id}]', 'rel ch had iso (0.3)', None, uniform(20, 0., 1.), is_per_muon=True),
    'neutiso3': t('{type}mu_neutHadEtR03[{id}]/{type}mu_pt[{id}]', 'rel neut had iso (0.3)', None, uniform(20, 0., 1.), is_per_muon=True),
    'photiso3': t('{type}mu_photonEtR03[{id}]/{type}mu_pt[{id}]', 'rel photon iso (0.3)', None, uniform(20, 0., 1.), is_per_muon=True),
    'trklessiso3': t('({type}mu_pfIso03[{id}]-{type}mu_chHadPtR03[{id}])/{type}mu_pt[{id}]', 'rel trkless iso (0.3)', None, uniform(10, 0., 2.), is_per_muon=True),
    'pfiso4': t('{type}mu_pfIso04[{id}]/{type}mu_pt[{id}]', 'rel pf iso (0.4)', None, uniform(20, 0., 2.), is_per_muon=True),
    'chiso4': t('{type}mu_chHadPtR04[{id}]/{type}mu_pt[{id}]', 'rel ch had iso (0.4)', None, uniform(20, 0., 1.), is_per_muon=True),
    'neutiso4': t('{type}mu_neutHadEtR04[{id}]/{type}mu_pt[{id}]', 'rel neut had iso (0.4)', None, uniform(20, 0., 1.), is_per_muon=True),
    'photiso4': t('{type}mu_photonEtR04[{id}]/{type}mu_pt[{id}]', 'rel photon iso (0.4)', None, uniform(20, 0., 1.), is_per_muon=True),
    'clniso': t('{type}mu_cleanedIso[{id}]/{type}mu_pt[{id}]', 'rel cleaned iso', None, uniform(20, 0., 0.1), is_per_muon=True),
    "genid": t("gen_pdgID[dim_mu{num}_gen_idx]", "gen pdgid", None, uniform(20, -50., 50), is_per_muon=True, is_gen=True),
    "genpt": t("gen_pt[dim_mu{num}_gen_idx]", "gen p_{T}", 'GeV/c', uniform(50, 0., 100), is_per_muon=True, is_gen=True),
    "geneta": t("gen_eta[dim_mu{num}_gen_idx]", "gen #eta", None, uniform(20, -3., 3.), is_per_muon=True, is_gen=True),
    "genphi": t("gen_phi[dim_mu{num}_gen_idx]", "gen #phi", None, uniform(20, -3.2, 3.2), is_per_muon=True, is_gen=True),
    "gend0bs": t("gen_d0[dim_mu{num}_gen_idx]", "gen d_{0} bs", 'cm', uniform(50, -0.025, 0.025), is_per_muon=True, is_gen=True),
    "genabsd0bs": t("abs(gen_d0[dim_mu{num}_gen_idx])", "gen |d_{0}| bs", 'cm', uniform(50, 0., 0.025), is_per_muon=True, is_gen=True),
    "genx": t("gen_x[dim_mu{num}_gen_idx]", "gen x", 'cm', uniform(10, 0., 10.), is_per_muon=True, is_gen=True),
    "geny": t("gen_y[dim_mu{num}_gen_idx]", "gen y", 'cm', uniform(10, 0., 10.), is_per_muon=True, is_gen=True),
    "genz": t("gen_z[dim_mu{num}_gen_idx]", "gen z", 'cm', uniform(10, 0., 10.), is_per_muon=True, is_gen=True),
    "gencharge": t("gen_charge[dim_mu{num}_gen_idx]", "gen charge", None, uniform_step_axis(1, -2., 2., align='center'), is_per_muon=True, is_gen=True),
}

dimdict = {
    "pscore": t("dim_pscore", "pscore", None, uniform(5, 0.5, 1.)),
    "nlpscore": t("-log10(dim_pscore)", "-log_{10}(p)", None, uniform(10, 0, 10)),
    "nl1mpscore": t("-log10(1-dim_pscore)", "-log_{10}(1-p)", None, uniform(10, 0, 10)),
    'maxDSAiso': t('max(dim_mu1_iso, dim_mu2_iso)', 'max(I^{rel}_{STA})', None, uniform(20, 0., 1.)),
    'maxHYBiso': t('max(dim_mu1_iso, patmu_trackIso[dim_mu2_idx-1000]/patmu_pt[dim_mu2_idx-1000])', 'max(I^{rel}_{HYB})', None, uniform(20, 0., 1.)),
    'maxPATiso': t('max(patmu_trackIso[dim_mu1_idx-1000]/patmu_pt[dim_mu1_idx-1000], patmu_trackIso[dim_mu2_idx-1000]/patmu_pt[dim_mu2_idx-1000])', 'max(I^{rel}_{TMS})', None, uniform(20, 0., 1.)),
    'maxDSAcleanedIso': t('max(dim_mu1_iso, dim_mu2_iso)', 'max(I^{rel}_{STA}(cleaned))', None, uniform(20, 0., 1.)),
    'maxHYBcleanedIso': t('max(dim_mu1_iso, dim_mu2_cleanedIso/patmu_pt[dim_mu2_idx-1000])', 'max(I^{rel}_{HYB}(cleaned))', None, uniform(20, 0., 1.)),
    'maxPATcleanedIso': t('max(dim_mu1_cleanedIso/patmu_pt[dim_mu1_idx-1000], dim_mu2_cleanedIso/patmu_pt[dim_mu2_idx-1000])', 'max(I^{rel}_{TMS}(cleaned))', None, uniform(20, 0., 1.)),
    "beta": t("dim_p/sqrt(dim_p*dim_p+dim_mass*dim_mass)", "beta", None, uniform(100, 0., 1.)),
    "mass": t("dim_mass", "m_{#mu#mu}", 'GeV', uniform(50, 0., 100.)),
    "largemass": t("dim_mass", "m_{#mu#mu}", 'GeV', uniform(50, 0., 500.)),
    "smallmass": t("dim_mass", "m_{#mu#mu}", 'GeV', uniform(160, 0., 20.)),
    "masssig": t("dim_mass/dim_massunc", "m_{#mu#mu}/#sigma_{m_{#mu#mu}}", None, uniform(50, 0., 100.)),
    "masszoomed": t("dim_mass", "m_{#mu#mu}", 'GeV', uniform(50, 0., 20.)),
    "smearedmass": t("mass(smearDSApT(dsamu_pt[{id1}]), dsamu_eta[{id1}], dsamu_phi[{id1}], smearDSApT(dsamu_pt[{id2}]), dsamu_eta[{id2}], dsamu_phi[{id2}])", "smeared m_{#mu#mu}", 'GeV', uniform(50, 0., 100.)),
    "unrefmass": t("sqrt(((sqrt(0.1057*0.1057 + {type1}mu_px[{id1}]*{type1}mu_px[{id1}] + {type1}mu_py[{id1}]*{type1}mu_py[{id1}] + {type1}mu_pz[{id1}]*{type1}mu_pz[{id1}]))+(sqrt(0.1057*0.1057 + {type2}mu_px[{id2}]*{type2}mu_px[{id2}] + {type2}mu_py[{id2}]*{type2}mu_py[{id2}] + {type2}mu_pz[{id2}]*{type2}mu_pz[{id2}])))**2 - ({type1}mu_px[{id1}]+{type2}mu_px[{id2}])**2 - ({type1}mu_py[{id1}]+{type2}mu_py[{id2}])**2 - ({type1}mu_pz[{id1}]+{type2}mu_pz[{id2}])**2)", "unreffitted m_{#mu#mu}", 'GeV', uniform(50, 0.0, 100.0)),
    "masscor": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)", "m_{#mu#mu}^{corr}", 'GeV', uniform(50, 0., 100.)),
    "dimpt": t("dim_pt", "dimuon p_{T}", 'GeV/c', uniform(20, 0., 100.)),
    "dimp": t("dim_p", "dimuon p", 'GeV/c', uniform(20, 0., 200.)),
    "dimeta": t("dim_eta", "dimuon #eta", None, uniform(50, -4., 4.)),
    "dimphi": t("dim_phi", "dimuon #phi", None, uniform(50, -4., 4.)),
    "absdimphi": t("abs(dim_phi)", "dimuon |#phi|", None, uniform(40, 0., 3.14159)),
    "absdimphishift": t("abs(dim_phi)-pi/2+((abs(dim_phi)-pi/2)<=0)*pi", "dimuon |#phi - #pi/2|", None, uniform(40, 0., 3.14159)),
    "ptoverm": t("dim_pt/dim_mass", "dimuon p_{T}/M_{#mu#mu}", None, uniform(50, 0., 5.)),
    "lxysigpv": t("dim_LxySig_pv", "L_{xy}/#sigma_{Lxy}", None, uniform(50, 0., 50.)),
    "lxysigbs": t("dim_LxySig_bs", "L_{xy}/#sigma_{L_{xy}} bs", None, uniform(50, 0., 50.)),
    "lxyerrpv": t("dim_Lxy_pv/dim_LxySig_pv", "#sigma_{L_{xy}} pv", 'cm', uniform(50, 0., 0.01)),
    "lxyerrbs": t("dim_Lxy_bs/dim_LxySig_bs", "#sigma_{L_{xy}} bs", 'cm', uniform(50, 0., 0.01)),
    "largelxyerrpv": t("dim_Lxy_pv/dim_LxySig_pv", "#sigma_{L_{xy}} pv", 'cm', uniform(100, 0., 100.)),
    "largelxyerrbs": t("dim_Lxy_bs/dim_LxySig_bs", "#sigma_{L_{xy}} bs", 'cm', uniform(100, 0., 100.)),
    "lxypv": t("dim_Lxy_pv", "L_{xy} pv", 'cm', uniform(50, 0., 0.1)),
    "lxybs": t("dim_Lxy_bs", "L_{xy} bs", 'cm', uniform(50, 0., 0.1)),
    "largelxypv": t("dim_Lxy_pv", "L_{xy} pv", 'cm', uniform(100, 0., 300)),
    "largelxybs": t("dim_Lxy_bs", "L_{xy} bs", 'cm', uniform(100, 0., 300)),
    "lxyphipv": t("phi(dim_x,dim_y,dim_z,vtx_pv_x,vtx_pv_y,vtx_pv_z)", '#phi_{Lxy}', None, uniform(20, -3.2, 3.2)),
    "lxysigbeytra": t("max((dim_Lxy_pv-70 )*dim_LxySig_pv/dim_Lxy_pv,0)", "(L_{xy}-70)/#sigma_{L_{xy}} pv", None, uniform(50, 0., 50.)),
    "lzpv": t("abs(dim_z-dim_rpv_z)", "L_{z}", 'cm', uniform(100, 0., 700.)),
    "lzp4": t("abs(dim_Lxy_pv*sinh(dim_eta))", "L_{z}(p^{#mu#mu})", 'cm', uniform(100, 0., 700.)),
    "difflz": t("abs(dim_z-dim_rpv_z)-abs(dim_Lxy_pv*sinh(dim_eta))", "L_{z}-L_{z}(p^{#mu#mu})", 'cm', uniform(100, 0., 500.)),
    "deltaphi": t("dim_deltaPhi", '|#Delta#Phi|', None, uniform(50, 0., 3.14159)),
    "ideltaphi": t("pi-dim_deltaPhi", '#pi - |#Delta#Phi|', None, uniform(50, 0., 3.14159)),
    "foldeddeltaphi1": t("abs(dim_deltaPhi-pi/2)", '| |#Delta#Phi| - #pi/2 |', None, uniform(50, 0., 1.5708)),
    "foldeddeltaphi2": t("abs(abs(dim_deltaPhi-pi/2)-pi/2)", '| | |#Delta#Phi| - #pi/2 | - #pi/2 |', None, uniform(50, 0., 1.5708)),
    "deltar": t("dim_deltaR", '#DeltaR(#mu#mu)', None, uniform(50, 0., 5.)),
    "cosalpha": t("dim_cosAlpha", 'ref cos(#alpha)', None, uniform(50, -1., 1.)),
    "cosalphao": t("dim_cosAlphaOrig", 'orig cos(#alpha)', None, uniform(50, -1., 1.)),
    "dca": t("dim_dca", 'D.C.A.', 'cm', uniform(20, 0., 0.1)),
    "largedca": t("dim_dca", 'D.C.A.', 'cm', uniform(100, 0., 100.)),
    "vtxnormchi2": t("dim_normChi2", "vtx #chi^{2}/dof", None, uniform(20, 0., 20.)),
    "passeschi2": t("(dim_normChi2<10)", "vtx. #chi^{2}/ndof < 10", None, uniform(2, -0.5, 1.5)),
    "met": t("met_pt", "MET", ' GeV', uniform(50, 0., 100.)),
    "pxldiff": t("abs({type1}mu_nPixelHits[{id1}]-{type2}mu_nPixelHits[{id2}])", "abs(pxl_{1}-pxl_{2})", None, uniform(6, 0., 6.)),
    "ptdiff": t("abs({type1}mu_pt[{id1}]-{type2}mu_pt[{id2}])", "abs(p_{T}(#mu_{1})-p_{T}(#mu_{2}))", 'GeV', uniform(70, 0., 70.)),
    "d0diff": t("abs({type1}mu_d0_pv[{id1}]-{type2}mu_d0_pv[{id2}])", "abs(d_{0}(#mu_{1})-d_{0}(#mu_{2}))", 'cm', uniform(30, 0., 0.03)),
    "tlaydiff": t("abs({type1}mu_nTrackerLayers[{id1}]-{type2}mu_nTrackerLayers[{id2}])", "abs(tlay_{1}-tlay_{2})", None, uniform(20, 0., 20.)),
    "qsum": t("{type1}mu_charge[{id1}]+{type2}mu_charge[{id2}]", "q_{1}+q_{2}", 'e', uniform_step_axis(1, -2., 2., align='center')),
    "absqsum": t("abs({type1}mu_charge[{id1}]+{type2}mu_charge[{id2}])", "|q_{1}+q_{2}|", 'e', uniform_step_axis(1, 0, 2., align='center')),
    "ct": t("dim_Lxy_pv*dim_mass/dim_pt", "proper decay time", 'cm', uniform(100, 0., 300.)),
    "genlxypv": t("gen_Lxy[dim_mu1_gen_idx]", "Generated L_{xy} pv", 'cm', uniform(50, 0., 0.1)),
    "gendeltax": t('gen_x[{type1}mu_gen_idx[{id1}]]-gen_x[{type2}mu_gen_idx[{id2}]]', 'gen x_{1} - x_{2}', 'cm', uniform(10, -0.01, 0.01)),
    "gendeltay": t('gen_y[{type1}mu_gen_idx[{id1}]]-gen_y[{type2}mu_gen_idx[{id2}]]', 'gen y_{1} - y_{2}', 'cm', uniform(10, -0.01, 0.01)),
    'diffphi': t('abs(deltaphi({type1}mu_phi[{id1}],{type2}mu_phi[{id2}]))', 'abs(#phi_{1}-#phi_{2})', None, uniform(100, 0, 2 * np.pi)),
    "diffeta": t('abs({type1}mu_eta[{id1}]-{type2}mu_eta[{id2}])', 'abs(#eta_{1}-#eta_{2})', None, uniform(100, 0, 5)),
    "gendeltax": t('gen_x[{type1}mu_gen_idx[{id1}]]-gen_x[{type2}mu_gen_idx[{id2}]]', 'gen x_{1} - x_{2}', 'cm', uniform(10, -0.01, 0.01)),
    "gendeltay": t('gen_y[{type1}mu_gen_idx[{id1}]]-gen_y[{type2}mu_gen_idx[{id2}]]', 'gen y_{1} - y_{2}', 'cm', uniform(10, -0.01, 0.01)),
    "genlxy": t('gen_Lxy[dim_mu1_gen_idx]', 'gen L_{xy}', 'cm', uniform(50, 0., 0.1)),
    "genx": t('gen_x[dim_mu1_gen_idx]', 'gen x', 'cm', uniform(50, 0., 10)),
    "geny": t('gen_y[dim_mu1_gen_idx]', 'gen y', 'cm', uniform(50, 0., 10)),
    "genz": t('abs(gen_z[dim_mu1_gen_idx])', 'gen |z|', 'cm', uniform(50, 0., 10)),
    "gencosalpha": t('gen_cosAlpha[dim_mu1_gen_idx]', 'gen cos#alpha', None, uniform(50, -1., 1.), is_gen=True),
    "gendeltar": t('gen_deltaR[dim_mu1_gen_idx]', 'gen #DeltaR(#mu#mu)', None, uniform(50, 0., 5.), is_gen=True),
    "genmass": t('gen_mass[dim_gen_idx]', 'gen dimuon mass', 'GeV', uniform(50, 0., 100.), is_gen=True),
    "gent": t('gen_Lxy[dim_mu1_gen_idx]*gen_mass[dim_gen_idx]/gen_pt[dim_gen_idx]', 'gen proper decay time', 'cm', uniform(50, 0., 100.), is_gen=True),
    "gendimeta": t('gen_eta[dim_gen_idx]', 'gen dimuon #eta', None, uniform(50, -4., 4.), is_gen=True),
    "gendimphi": t('gen_phi[dim_gen_idx]', 'gen dimuon #phi', None, uniform(50, -4., 4.), is_gen=True),
    "genmassdiff": t('gen_mass[dim_gen_idx]-dim_mass', 'gen - reco dimuon mass', 'GeV', uniform(40, -20., 20.), is_gen=True),
    "genmassdiffrat": t('(gen_mass[dim_gen_idx]-dim_mass)/gen_mass[dim_gen_idx]', 'gen - reco / gen dimuon mass', 'GeV', uniform(40, -1., 1.), is_gen=True),
    "genbeta": t('sqrt(gen_energy[dim_gen_idx]**2-gen_mass[dim_gen_idx]**2)/gen_energy[dim_gen_idx]', 'gen beta', None, uniform(50, 0., 1.), is_gen=True),
    "PATmass": t("dim_mass[dim_dim_idx]", "m^{(assoc. PAT-PAT)}_{#mu#mu}", 'GeV', uniform(50, 0., 100.)),
    "TMSmass": t("dim_mass[dim_dim_idx]", "m^{(assoc. TMS-TMS)}_{#mu#mu}", 'GeV', uniform(50, 0., 100.)),
    "PATdeltaphi": t("dim_deltaPhi[dim_dim_idx]", "assoc. PAT |#Delta#Phi|", None, uniform(50, 0., 3.14159)),
    "PATdeltar": t("dim_deltaR[dim_dim_idx]", "assoc. PAT #DeltaR(#mu#mu)", None, uniform(50, 0., 5.)),
    "PATmasszoomed": t("dim_mass[dim_dim_idx]", "assoc. PAT M_{#mu#mu}", 'GeV', uniform(50, 0., 20.)),
    "dimnseg": t("dsamu_nDTStations[{id1}] + dsamu_nDTStations[{id2}] + dsamu_nCSCStations[{id1}] + dsamu_nCSCStations[{id2}]", "dimuon N_{segm}", None, uniform(10, 0, 10)),
    "dimdeltaeta": t("dsamu_eta[{id1}]-dsamu_eta[{id2}]", "dimuon #Delta#eta", None, uniform(50, -0.5, 0.5)),
    "dimrefdeltaeta": t("dim_mu{num1}_eta-dim_mu{num2}_eta", "dimuon ref. #Delta#eta", None, uniform(50, -0.5, 0.5)),
    "dimdeltaphi": t("acos(cos(dsamu_phi[{id1}]-dsamu_phi[{id2}]))", "dimuon #Delta#phi", None, uniform(50, 0., 1.5)),
    "dimrefdeltaphi": t("acos(cos(dim_mu1_phi-dim_mu2_phi))", "dimuon ref. #Delta#phi", None, uniform(50, 0., 1.5)),
    "dimPATdeltaeta": t("abs(patmu_eta[dim_mu1_idx[dim_dim_idx]-1000]-patmu_eta[dim_mu2_idx[dim_dim_idx]-1000])", "PAT dimuon #Delta#eta", None, uniform(50, 0., 0.3)),
    "dimPATdeltaphi": t("acos(cos(patmu_phi[dim_mu1_idx[dim_dim_idx]-1000]-patmu_phi[dim_mu2_idx[dim_dim_idx]-1000]))", "PAT dimuon #Delta#phi", None, uniform(50, 0., 1.5)),
    'timediff': t('{type1}mu_timeAtIpInOut[{id1}] - {type2}mu_timeAtIpInOut[{id2}]', '#Delta t', 'ns', uniform(60, -30, 30)),
    'maxabstime': t('max(abs({type1}mu_timeAtIpInOut[{id1}]), abs({type2}mu_timeAtIpInOut[{id2}]))', 'max. |t|', 'ns', uniform(50, 0, 70)),
    'sumpt': t('{type1}mu_pt[{id1}]+{type2}mu_pt[{id2}]', 'sum muon p_{T}', 'GeV/c', uniform(50, 0., 100.)),
    'minbbdsatimediff': t('min(abs({type1}mu_timeAtIpInOut[{id1}] - dim_BBDSA_timeAtIpInOut), abs({type2}mu_timeAtIpInOut[{id2}] - dim_BBDSA_timeAtIpInOut))', 'minimum #Delta t with back-to-back DSA muon', 'ns', uniform(60, 0.0, 120.0)),
    "diffrecogenlxy": t('dim_Lxy_pv-gen_Lxy[dim_mu1_gen_idx]', 'reco L_{xy} #minus gen L_{xy}', 'cm', uniform(50, 0., 100.)),
    "diffrecogenmass": t('dim_mass-gen_mass[dim_gen_idx]', 'reco #minus gen mass', 'GeV', uniform(50, 0., 100.)),
    "diffrecogenmassrel": t('(dim_mass-gen_mass[dim_gen_idx])/gen_mass[dim_gen_idx]', '(reco #minus gen)/gen mass', None, uniform(50, -2., 2.)),
    "ctau": t('0', 'c#tau', 'cm', uniform(1000, 1e-4, 1e7)),
    "dimr": t("hypot(dim_x,dim_y)", "R(Displaced Vertex)", 'cm', uniform(100, 0., 500.)),
    "dimx": t("dim_x", "X(Displaced Vertex)", 'cm', uniform(100, -500., 500.)),
    "dimy": t("dim_y", "Y(Displaced Vertex)", 'cm', uniform(100, -500., 500.)),
    "dimz": t("dim_z", "Z(Displaced Vertex)", 'cm', uniform(100, -700., 700.)),
    "dimetavtx": t("-log(tan(atan2(hypot(dim_x,dim_y),dim_z)/2))", "#eta(Displaced Vertex)", None, uniform(50, -4., 4.)),
    "dimphivtx": t("atan2(dim_y, dim_x)", "#phi(Displaced Vertex)", None, uniform(50, -4., 4.)),
    "maxabsd0pv": t("max(abs({type1}mu_d0_pv[{id1}]), abs({type2}mu_d0_pv[{id2}]))", "max |d_{0}| pv", 'cm', uniform(50, -0.025, 0.025)),
    'dimgenid': t('dim_gen_idx', 'gen index', None, uniform(20, 0., 20.), is_gen=True),
    # Lxy vector is not stored for QCD MC, so need to recompute. Should be identical between muons
    'proxgenlxy': t('sqrt((gen_x[patmu_gen_idx[{id1}]]-bs_x)**2+(gen_y[patmu_gen_idx[{id1}]]-bs_y)**2)', 'gen Lxy', 'cm', uniform(50, 0., 0.1), is_gen=True),
}

deprecateddimdict = {
    "hltmass": t( \
        "mass(sqrt(trig_hltmu_px[{trigid1}]**2+trig_hltmu_py[{trigid1}]**2),\
        trig_hltmu_eta[{trigid1}],\
        trig_hltmu_phi[{trigid1}],\
        sqrt(trig_hltmu_px[{trigid2}]**2+trig_hltmu_py[{trigid2}]**2),\
        trig_hltmu_eta[{trigid2}],\
        trig_hltmu_phi[{trigid2}])".format(trigid1='{type1}mu_hltmu_pp_idx[{id1}]', trigid2='{type2}mu_hltmu_pp_idx[{id2}]'),
        'hlt mass', 'GeV', uniform(50, 0., 100.)
    ),
    "hltcosalpha": t( \
        "cosalpha(sqrt(trig_hltmu_px[{trigid1}]**2+trig_hltmu_py[{trigid1}]**2),\
        trig_hltmu_eta[{trigid1}],\
        trig_hltmu_phi[{trigid1}],\
        sqrt(trig_hltmu_px[{trigid2}]**2+trig_hltmu_py[{trigid2}]**2),\
        trig_hltmu_eta[{trigid2}],\
        trig_hltmu_phi[{trigid2}])".format(trigid1='{type1}mu_hltmu_pp_idx[{id1}]', trigid2='{type2}mu_hltmu_pp_idx[{id2}]'),
        'hlt cos(#alpha)', None, uniform(50, -1., 1.)
    ),
    "dimtype": t("dim_type", "dimuon type", None, uniform(50, 0., 50.)),
    "logdca": t("TMath::Log10(dim_dca)", 'Log_{10}(D.C.A. [cm])', None, uniform(50, -4., 2.)),
    "logetaphi": t('TMath::Log10(abs(({type1}mu_eta[{id1}]-{type2}mu_eta[{id2}])/({type1}mu_phi[{id1}]-{type2}mu_phi[{id2}])))', 'Log_{10}(|#Delta#eta/#Delta#phi|)', None, uniform(40, -5., 5)),
    "d0sig1": t('patmu_d0sig_bs[{id1}]', '#mu_{1} d_{0}/#sigma_{d_{0}} bs', None, uniform(20, 0., 10.)),
    "d0sig2": t('patmu_d0sig_bs[{id2}]', '#mu_{2} d_{0}/#sigma_{d_{0}} bs', None, uniform(20, 0., 10.)),
    "d02": t('patmu_d0_bs[{id2}]', '#mu_{2} d_{0} bs', None, uniform(20, 0., 0.025)),
    "tausig": t("1./sqrt((1./dim_LxySig_pv)**2+(dim_massunc/dim_mass)**2)", "#tau/#sigma_{#tau}", None, uniform(50, 0., 50.)),
    "sumkink": t("{type1}mu_kinkchi2[{id1}]+{type2}mu_kinkchi2[{id2}]", "sum(kink #chi^{2})", None, uniform(20, 0., 40.)),
    "sumb4vtx": t("dim_mu{num1}_hitsBeforeVtx+dim_mu{num2}_hitsBeforeVtx", "sum(hits before vertex)", None, uniform(20, 0., 20.)),
    "summissinghits": t("dim_mu{num1}_missingHitsAfterVtx+dim_mu{num2}_missingHitsAfterVtx", "sum(missing hits)", None, uniform(20, 0., 20.)),
    "logvtxchi2": t("TMath::Log10(dim_normChi2)", "Log_{10}(vtx #chi^{2}/dof)", None, uniform(20, -2., 8.)),

}

genmudict = {
    "rawgenmupt": t("{type}_pt[{id}]", 'gen #mu p_{T}', 'GeV/c', uniform(50, 0., 100), is_per_muon=True, is_gen=True),
    "rawgenmud0bs": t("{type}_d0[{id}]", 'gen #mu d_{0} bs', 'cm', uniform(20, 0., 0.025), is_per_muon=True, is_gen=True),
    "rawgenmueta": t("{type}_eta[{id}]", 'gen #mu #eta', None, uniform(20, -3., 3.), is_per_muon=True, is_gen=True),
    "rawgenmuphi": t("{type}_phi[{id}]", 'gen #mu #phi', None, uniform(20, -3.2, 3.2), is_per_muon=True, is_gen=True),
}

gendict = {
    "rawgenlxy": t("gen_Lxy[0]", 'gen L_{xy}', 'cm', uniform(50, 0., 0.1), is_gen=True),
    # only for the 2mu2j sample
    "gent": t('gen_Lxy[0]*gen_mass[4]/gen_pt[4]', 'gen proper decay time', 'cm', uniform(50, 0., 100.), is_gen=True),
    "gencosalpha": t('gen_cosAlpha[0]', 'gen cos#alpha', None, uniform(50, -1., 1.), is_gen=True),
    "gendimpt": t("gen_pt[4]", 'gen dim p_{T}', 'cm', uniform(50, 0., 0.1), is_gen=True),
    "gendimeta": t("gen_eta[4]", 'gen dim #eta', 'cm', uniform(50, -3.2, 3.2), is_gen=True),

}

evtdict = {
    # todo: implement trigger variables
    "pptrig": t("0", "pp trigger fired", None, uniform(2, 0, 2), is_event_var=True),
    "cosmictrig": t("0", "cosmic trigger fired", None, uniform(2, 0, 2), is_event_var=True),
    "run": t("evt_run", "Event Run", is_event_var=True),
    "lumi": t("evt_lumi", "Event Lumi", is_event_var=True),
    "event": t("evt_event", "Event Event", is_event_var=True),
    "bx": t("evt_bx", "Event Bunch Crossing", is_event_var=True),
    "weightsign": t("2.*((gen_weight>0)-0.5)", "Gen Weight Sign", is_event_var=True),
    "bsx": t("bs_x", "Beamspot X", 'cm', uniform(10, 0, 10), is_event_var=True),
    "bsy": t("bs_y", "Beamspot Y", 'cm', uniform(10, 0, 10), is_event_var=True),
    "bsz": t("bs_z", "Beamspot Z", 'cm', uniform(10, 0, 10), is_event_var=True),
    "nhlt": t("Length$(trig_hltmu_idx)", 'n(hlt muons)', None, uniform(10, 0, 10), is_event_var=True),
    "nvtx": t("vtx_nvtx", 'n(vertices)', None, uniform(50, 0, 50), is_event_var=True),
    "nseldsadims": t("evt_nDSASel", 'n(selected DSA-DSA dimuons)', None, uniform(5, 0, 5), is_event_var=True),
    "nselpatdims": t("evt_nPATSel", 'n(selected PAT-PAT dimuons)', None, uniform(5, 0, 5), is_event_var=True),
    "nselhybdims": t("evt_nHYBSel", 'n(selected DSA-PAT dimuons)', None, uniform(5, 0, 5), is_event_var=True),
    "npp": t("evt_nParallelPairs", 'n(parallel DSA muon pairs)', None, uniform(40, 0, 40), is_event_var=True),
    "nppm": t("evt_nParallelPairsMinus", 'n(parallel DSA muon pairs with #cos#alpha < -0.99)', None, uniform(40, 0, 40), is_event_var=True),
    "nppp": t("evt_nParallelPairsPlus", 'n(parallel DSA muon pairs with #cos#alpha > +0.99)', None, uniform(40, 0, 40), is_event_var=True),
}
